<!doctype html>
<html>
<head>
	<meta charset="UTF-8" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link href="../css/tailwind.min.css" rel="stylesheet">
	<title>org.wasmcloud.model</title>
    <script src="https://cdn.jsdelivr.net/gh/alpinejs/alpine@v2.x.x/dist/alpine.min.js" type="text/javascript" defer></script>
    <script src='https://cdn.jsdelivr.net/npm/fuse.js@6.4.6/dist/fuse.min.js' type="text/javascript"></script>
</head>
<body class="p-4">

    <div id="content">
        <div class="p-4 overflow-y-auto">
            <h1 id="org_wasmcloud_model" class="text-2xl font-serif">Namespace org.wasmcloud.model</h1>
            <div class="table m-4 ml-12">
                            <div class="table-row">
                                <div class="table-cell align-top pr-6 w-28">
                                    Traits
                                </div>
                                <div class="table-cell align-top">
                                    <ul>
<li class="font-light"><a href="#org_wasmcloud_model_codegen_rust"><a href="#codegen_rust">codegenRust</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_extends"><a href="#extends">extends</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_n"><a href="#n">n</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_non_empty_string"><a href="#non_empty_string">nonEmptyString</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_rename"><a href="#rename">rename</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_rename_item"><a href="#rename_item">renameItem</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_serialization"><a href="#serialization">serialization</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_synonym"><a href="#synonym">synonym</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_unsigned_int"><a href="#unsigned_int">unsignedInt</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_wasmbus"><a href="#wasmbus">wasmbus</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_wasmbus_data"><a href="#wasmbus_data">wasmbusData</a></a></li>                    </ul>
                                </div>
                            </div>
                            <div class="table-row">
                                <div class="table-cell align-top pr-6 w-28">
                                    Simple
                                </div>
                                <div class="table-cell align-top">
                                    <ul>
<li class="font-light"><a href="#org_wasmcloud_model_capability_contract_id"><a href="#capability_contract_id">CapabilityContractId</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_f32"><a href="#f32">F32</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_f64"><a href="#f64">F64</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_i8"><a href="#i8">I8</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_i16"><a href="#i16">I16</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_i32"><a href="#i32">I32</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_i64"><a href="#i64">I64</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_u8"><a href="#u8">U8</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_u16"><a href="#u16">U16</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_u32"><a href="#u32">U32</a></a></li><li class="font-light"><a href="#org_wasmcloud_model_u64"><a href="#u64">U64</a></a></li>                    </ul>
                                </div>
                            </div>
                            <div class="table-row">
                                <div class="table-cell align-top pr-6 w-28">
                                    Lists
                                </div>
                                <div class="table-cell align-top">
                                    <ul>
<li class="font-light"><a href="#org_wasmcloud_model_identifier_list"><a href="#identifier_list">IdentifierList</a></a></li>                    </ul>
                                </div>
                            </div>            </div>

    
        <h2 id="capability_contract_id" class="mt-8 border-t-2 border-gray-300">
            <a href="#capability_contract_id">CapabilityContractId</a><span class="text-lg pl-4">(string)</span>
        </h2><p class="font-light ml-6">Capability contract id, e.g. 'wasmcloud:httpserver'</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#non_empty_string">nonEmptyString</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="codegen_rust" class="mt-8 border-t-2 border-gray-300">
            <a href="#codegen_rust">codegenRust</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">Rust codegen traits</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>                <tr>
                                        <td>noDeriveDefault:</td>
                                        <td>Boolean</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>                <tr>
                                        <td>noDeriveEq:</td>
                                        <td>Boolean</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>                <tr>
                                        <td>nonExhaustive:</td>
                                        <td>Boolean</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>            </tbody>
                            </table>
                        </div>
                        

    
        <h2 id="extends" class="mt-8 border-t-2 border-gray-300">
            <a href="#extends">extends</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">indicates that a trait or class extends one or more bases</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>                <tr>
                                        <td>base:</td>
                                        <td><a href="#identifier_list">IdentifierList</a></td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>            </tbody>
                            </table>
                        </div>
                        

    
        <h2 id="f32" class="mt-8 border-t-2 border-gray-300">
            <a href="#f32">F32</a><span class="text-lg pl-4">(float)</span>
        </h2><p class="font-light ml-6">32-bit float</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#synonym">synonym</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="f64" class="mt-8 border-t-2 border-gray-300">
            <a href="#f64">F64</a><span class="text-lg pl-4">(double)</span>
        </h2><p class="font-light ml-6">64-bit float aka double</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#synonym">synonym</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="i8" class="mt-8 border-t-2 border-gray-300">
            <a href="#i8">I8</a><span class="text-lg pl-4">(byte)</span>
        </h2><p class="font-light ml-6">signed byte</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#synonym">synonym</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="i16" class="mt-8 border-t-2 border-gray-300">
            <a href="#i16">I16</a><span class="text-lg pl-4">(short)</span>
        </h2><p class="font-light ml-6">signed 16-bit int</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#synonym">synonym</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="i32" class="mt-8 border-t-2 border-gray-300">
            <a href="#i32">I32</a><span class="text-lg pl-4">(integer)</span>
        </h2><p class="font-light ml-6">signed 32-bit int</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#synonym">synonym</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="i64" class="mt-8 border-t-2 border-gray-300">
            <a href="#i64">I64</a><span class="text-lg pl-4">(long)</span>
        </h2><p class="font-light ml-6">signed 64-bit int</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#synonym">synonym</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



                        
                            <h2 id="identifier_list" class="mt-8 border-t-2 border-gray-300">
                                <a href="#identifier_list">IdentifierList</a><span class="text-lg pl-4">(list)</span>
                            </h2><p class="font-light ml-6">list of identifiers</p>
                        <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr>
                                    <td>member:</td>
                                    <td>String</td>
                                    <td><span class="font-light">&nbsp;</span></td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                        



    
        <h2 id="n" class="mt-8 border-t-2 border-gray-300">
            <a href="#n">n</a><span class="text-lg pl-4">(short)</span>
        </h2><p class="font-light ml-6">Field sequence number. A zero-based field number for each member of a structure,
to enable deterministic cbor serialization and improve forward and backward compatibility.
Although the values are not required to be sequential, gaps are filled with nulls
during encoding and so will slightly increase the encoding size.</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>            </tbody>
                            </table>
                        </div>
                        
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td>range</td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>

    
        <h2 id="non_empty_string" class="mt-8 border-t-2 border-gray-300">
            <a href="#non_empty_string">nonEmptyString</a><span class="text-lg pl-4">(string)</span>
        </h2><p class="font-light ml-6">A non-empty string (minimum length 1)</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>            </tbody>
                            </table>
                        </div>
                        
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td>length</td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>

    
        <h2 id="rename" class="mt-8 border-t-2 border-gray-300">
            <a href="#rename">rename</a><span class="text-lg pl-4">(list)</span>
        </h2><p class="font-light ml-6">Rename item(s) in target language.
Useful if the item name (operation, or field) conflicts with a keyword in the target language.
example: @rename({lang:"python",name:"delete"})</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>            </tbody>
                            </table>
                        </div>
                        

    
        <h2 id="rename_item" class="mt-8 border-t-2 border-gray-300">
            <a href="#rename_item">renameItem</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">list element of trait @rename. the item name in the target language
see '@rename'</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>                <tr>
                                        <td>lang:</td>
                                        <td>String</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>                <tr>
                                        <td>name:</td>
                                        <td>String</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>            </tbody>
                            </table>
                        </div>
                        

    
        <h2 id="serialization" class="mt-8 border-t-2 border-gray-300">
            <a href="#serialization">serialization</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">Overrides for serializer & deserializer</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>                <tr>
                                        <td>name:</td>
                                        <td>String</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>            </tbody>
                            </table>
                        </div>
                        

    
        <h2 id="synonym" class="mt-8 border-t-2 border-gray-300">
            <a href="#synonym">synonym</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">This trait doesn't have any functional impact on codegen. It is simply
to document that the defined type is a synonym, and to silence
the default validator that prints a notice for synonyms with no traits.</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>            </tbody>
                            </table>
                        </div>
                        

    
        <h2 id="u8" class="mt-8 border-t-2 border-gray-300">
            <a href="#u8">U8</a><span class="text-lg pl-4">(byte)</span>
        </h2><p class="font-light ml-6">unsigned byte</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#unsigned_int">unsignedInt</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="u16" class="mt-8 border-t-2 border-gray-300">
            <a href="#u16">U16</a><span class="text-lg pl-4">(short)</span>
        </h2><p class="font-light ml-6">unsigned 16-bit int</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#unsigned_int">unsignedInt</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="u32" class="mt-8 border-t-2 border-gray-300">
            <a href="#u32">U32</a><span class="text-lg pl-4">(integer)</span>
        </h2><p class="font-light ml-6">unsigned 32-bit int</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#unsigned_int">unsignedInt</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="u64" class="mt-8 border-t-2 border-gray-300">
            <a href="#u64">U64</a><span class="text-lg pl-4">(long)</span>
        </h2><p class="font-light ml-6">unsigned 64-bit int</p>
    
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td><a href="#unsigned_int">unsignedInt</a></td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>



    
        <h2 id="unsigned_int" class="mt-8 border-t-2 border-gray-300">
            <a href="#unsigned_int">unsignedInt</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">The unsignedInt trait indicates that one of the number types is unsigned</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>            </tbody>
                            </table>
                        </div>
                        
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td>range</td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>

    
        <h2 id="wasmbus" class="mt-8 border-t-2 border-gray-300">
            <a href="#wasmbus">wasmbus</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">a protocol defines the semantics
of how a client and server communicate.</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>                <tr>
                                        <td>actorReceive:</td>
                                        <td>Boolean</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>                <tr>
                                        <td>contractId:</td>
                                        <td><a href="#capability_contract_id">CapabilityContractId</a></td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>                <tr>
                                        <td>protocol:</td>
                                        <td>String</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>                <tr>
                                        <td>providerReceive:</td>
                                        <td>Boolean</td>
                                        <td>&nbsp;</td>
                                        <!--
                                        <td><span class="font-light">[object] </span> </td>
                                        -->
                                    </tr>            </tbody>
                            </table>
                        </div>
                        
        <div class="ml-12">
                <p class="font-medium mt-4">Traits
                <p>
                <table>                    <tr>
                            <td>protocolDefinition</td>
                                <td>[object]</td>
                    </tr>            </table>
            </div>

    
        <h2 id="wasmbus_data" class="mt-8 border-t-2 border-gray-300">
            <a href="#wasmbus_data">wasmbusData</a><span class="text-lg pl-4">(structure)</span>
        </h2><p class="font-light ml-6">data sent via wasmbus
This trait is required for all messages sent via wasmbus</p>
    <div class="ml-12">
                            <table>
                                <thead>
                                <tr>
                                    <th class="w-48"></th>
                                    <th class="w-48"></th>
                                    <th class=""></th>
                                </tr>
                                </thead>
                                <tbody>            </tbody>
                            </table>
                        </div>
                        
        </div>
    </div></body>
</html>
